function [x] = rndlc(n, seed, a, b, m)

% This function produces n random numbers using the Linear Congruential Method
% inputs: n is the number of the values to be produced starting from seed,
% (a, b, m) are the parameters of the linear congruency x_i = (a * x_{i-1} + b) mod m
% output: a column of n random numbers

x = zeros(n, 1); % initialize

temp = seed; % set seed to begin

for i = 1:n
    
    temp = mod(a *  temp + b, m); % evaluate congruency 
    
    x(i) = temp / m; % divide with m to be inside (0, 1)
    
end
    

end