function [x] = mypoisrnd(n, lam)
% draw sample of size n from Poisson(lambda)
% p_{i+1} = lambda/(i+1) * p_i <-- known recurrence
x = zeros(n, 1); % initialize

for i = 1:n

    u = rand;
    j = 0;
    flag = 1;
    prob = exp(-lam); 
    csum = prob;
    while flag % terminate for flag = 0
        if u <= csum % accept
            x(i) = j; % set value
            flag = 0;
        else
            prob = lam * prob / (j+1); % calculate value of recurrence
            j = j + 1; % increase counter
            csum = csum + prob; % increase sum
        end
    end


end